#!/bin/nawk -f
# All Rights Reserved, Copyright FUJITSU Limited, 2007-2009
#***********************************************************************
# ǽ            ѥ֥ͥåȤSystemwalker Operation Manager
#                     Ͽޤ
# ¹Է            SetJobnet ץ̾ ƥץ졼ȼ̻ [-d ǥ쥯ȥ̾] 
#                     [ư] [-time ư] -bkup Хååǥ쥯ȥ  
#                     [-g ] [-c ̥ץ] [-sys ֥ƥֹ]
# ѥ᥿      
# 			1.ƥץ졼ȼ̻: shutdown åȥƥץ졼
#                                             reboot   ֡ȥƥץ졼
#			       		      log_OS   ƥץ졼
#					      def_bkup_OS Хååץƥץ졼
#			2.ǥ쥯ȥ̾:     ƥץ졼Ȥ򥳥ԡƻѤ˻
#			3.ư:             -everyday 
#			 	              -monthly  DD"LAST"
#				              -weekly   轵WWW
#			4.ư:           ֥ͥåȤεư
#			5.Хåå
#			  ǥ쥯ȥ:       Хååǥ쥯ȥ̾(Хååץƥץ졼Ȼѻ)
#			6.:             (Хååץƥץ졼Ȼѻ)
#			7.̥ץ:     Хååץեΰ̵ͭ(Хååץƥץ졼Ȼѻ)
#			8.֥ƥֹ:   ʣ֥ƥ౿Ѥ򤷤Ƥ륷ƥǡоݤꤹ˻
#***********************************************************************
# ǿ             (ʵ)
# 0001                           
# 0002               2009/1/19   SEб
#***********************************************************************
BEGIN {
	#*************************************************
	# Ķ 
	#*************************************************
	"uname" | getline osname
	close("uname")

	#*************************************************
	# ƥץ졼ȥѥ
	#*************************************************
	template_path = "/var/opt/FJSVoptm/"

	#*************************************************
	# Ǽѥ
	#*************************************************
	shell_path = "/var/opt/FJSVoptm/SetJobnet"

	#*************************************************
	# ƥץ졼ȼ̻
	#*************************************************
	template_shutdown = "shutdown"
	template_reboot = "reboot"
	template_logOS = "log_OS"
	template_defbkupOS = "def_bkup_OS"
	
	#*************************************************
	# ץǼǥ쥯ȥ
	#*************************************************
	shutdown_dir = "/bin"
	reboot_dir = "/bin"
	logOS_dir = "/bin"
	defbkup_dir = "/bin"

	#*************************************************
	# ƥץ졼Ѱե
	#*************************************************
	tmp_file = "template.def"

	#*************************************************
	# եѰե
	#*************************************************
	def_file = "deffile.def"

	#*************************************************
	# ǥե
	#*************************************************
	default_gen = 365	
	default_comp = "ON"	
	min_day = 1	
	max_day = 31	
	min_hour = 0	
	max_hour = 23
	min_min = 0
	max_min = 59
	min_sys = 0
	max_sys = 9
	min_gen = 1
	max_gen = 500
	max_dir = 999

	#*************************************************
	# Ѵ 
	#*************************************************
	# 顼åե
	pbkupdir = sprintf("%s", shell_path)
	errmsgfilename="SetJobnet_errmsg"
	errmsgfile = sprintf("%s/%s", pbkupdir, errmsgfilename)
	# ֥ͥå̾(ư)ե
	condition_name="SetJobnet_condmsg"
	conditionfile = sprintf("%s/%s", pbkupdir, condition_name)
	# iconvޥ
	ICONVCMD="/usr/bin/iconv"
	# LANG
	mylang=sprintf("%s", ENVIRON["LANG"])
	# iconvѴơ֥
	if (osname == "SunOS") {
		# Solarisξ
		iconveuc = "eucJP"
		if ( mylang == "ja_JP.PCK" ) {
			# SJISξ
			toiconv = "PCK"
		} else {
			if ( mylang == "ja_JP.UTF-8" ) {
				# UTF8ξ
				toiconv = "UTF-8"
			}
		}
	} else {
		# Linuxξ
		iconveuc = "EUC-JP-MS"
		if ( mylang == "ja_JP.UTF-8" ) {
			# UTF8ξ
			toiconv = "UTF-8"
		}
	}

	# åΥѴ(顼å)
	if (mylang == "ja_JP.PCK" || mylang == "ja_JP.UTF-8" || mylang == "ja_JP.utf8") {
		errmsgrdcmd=sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgfile)
	} else {
		errmsgrdcmd = sprintf("cat %s", errmsgfile)
	}
	while (errmsgrdcmd | getline > 0) {
		errmsgrl = $0
	
		# Ԥ⤷ϹƬ"#"ξɤФ
		if ( errmsgrl == "" || errmsgrl ~ /^\#/ ) {
			continue
		}

		split(errmsgrl,edata,",")

		# ǡɤ߹
		errmsg[edata[1]] = edata[2]
	}
	close(errmsgrdcmd)

	# åΥѴ(֥ͥå̾(ư))
	if (mylang == "ja_JP.PCK" || mylang == "ja_JP.UTF-8" || mylang == "ja_JP.utf8") {
		conditioncmd=sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, conditionfile)
	} else {
		conditioncmd = sprintf("cat %s", conditionfile)
	}
	while (conditioncmd | getline > 0) {
		conditionrl = $0
	
		# Ԥ⤷ϹƬ"#"ξɤФ
		if ( conditionrl == "" || conditionrl ~ /^\#/ ) {
			continue
		}

		split(conditionrl,edata,",")

		# ǡɤ߹
		kanji_char[edata[1]] = edata[2]
	}
	close(conditioncmd)

	#*************************************************
	#ץ̾å 裱
	#*************************************************

	if (ARGV[1] == ""){
		printf("%s\n", errmsg[1])
		exit (1)
	}

	#*************************************************
	# ƥץ졼ȥեå裲
	#*************************************************

	if (ARGV[2] == ""){
		printf("%s\n", errmsg[36])
		exit (1)
	}
	if ((ARGV[2] != template_shutdown) && (ARGV[2] != template_reboot) && (ARGV[2] != template_logOS) && (ARGV[2] != template_defbkupOS)){
		printf("%s\n", errmsg[2])
		exit (1)
	}

	#*************************************************
	# ƥץ졼ȡХååץեץѥå
	#*************************************************
	if (ARGV[2] == template_shutdown){
		template_name = "omgr_shutdown.txt"
		jobnet_name_1 = "sd"
		jobnet_name_2 = template_shutdown
		prog_path = shutdown_dir
	}else if (ARGV[2] == template_reboot){
		template_name = "omgr_reboot.txt"
		jobnet_name_1 = "rbt"
		jobnet_name_2 = template_reboot
		prog_path = reboot_dir
	}else if (ARGV[2] == template_logOS){
		template_name = "omgr_oslog.txt"
		jobnet_name_1 = "logOS"
		jobnet_name_2 = template_logOS
		prog_path = logOS_dir
	}else if (ARGV[2] == template_defbkupOS){
		template_name = "omgr_osbkup.txt"
		jobnet_name_1 = "defOS"
		jobnet_name_2 = template_defbkupOS
		prog_path = defbkup_dir
	}
	if (osname == "SunOS") {
		if (ARGV[2] == template_logOS){
			bkfile_name = "OS_log_sol.def"
		}else if (ARGV[2] == template_defbkupOS){
			bkfile_name = "OS_bkup_sol.def"
		}
	} else {
		if (ARGV[2] == template_logOS){
			bkfile_name = "OS_log_lin.def"
		}else if (ARGV[2] == template_defbkupOS){
			bkfile_name = "OS_bkup_lin.def"
		}
	}

	mainProc()
	exit (0)
}

#*************************************************
# ᥤ
#*************************************************
function mainProc(){

#***********************************************************************************************
# ưưХååץǥ쥯ȥꡢ֥ƥֹ,ֹ桢̣ϣΡϣƣƤ
#***********************************************************************************************

# ź
index00 = 3
# ư 
start_day =""
# ư 
start_time= ""
# ֥ƥֹ 
sub_sys = ""
# ֹ
gen = ""
# ̣ϣΡϣƣ
comp = ""
# Хååץǥ쥯ȥ
bkup_path = ""
# ƥץ졼ȼ̻ҡեѥ̾
dir_path = ""
# ǥ쥯ȥ̵ͭե饰("":̵ 1:ͭ) 
d_flg = ""
# Хåå̵ͭե饰("":̵ 1:ͭ)
bkup_flg = ""
# ưʸ 
start_disp = ""
# ⤷Σʸ 
start_disp1 = ""
# -dץ̤ѻΥǥ쥯ȥ̾ղä 
index_num = ""
# ưʣϥåѥ
start_count = 0
# ֥ƥֹե饰(0:̵ 1:ͭ)
subsys_flg = "0"


while (1) {

	if ( ARGV[index00] =="" ){
		break;
	}else if (ARGV[index00] == "-d"){
		dirpath_proc(index00)
		index00++
		index00++
		d_flg = "1"
	}else if (ARGV[index00] == "-everyday"){
		everyday_proc()
		index00++
		start_count++
	}else if (ARGV[index00] == "-weekly"){
		weekly_proc(index00)
		index00++
		index00++
		start_count++
	}else if (ARGV[index00] == "-monthly"){
		monthly_proc(index00)
		index00++
		index00++
		start_count++
	}else if (ARGV[index00] == "-time"){
		time_proc(index00)
		index00++
		index00++
	}else if (ARGV[index00] == "-bkup"){
		bkup_proc(index00)
		index00++
		index00++
		bkup_flg = "1"
	}else if (ARGV[index00] == "-sys"){
		subsys_proc(index00)
		index00++
		index00++
		subsys_flg = "1"
	}else if (ARGV[index00] == "-g"){
		gen_proc(index00)
		index00++
		index00++
	}else if (ARGV[index00] == "-c"){
		comp_proc(index00)
		index00++
		index00++
	}else{		
		printf("%s\n", errmsg[3])
		exit (1)
	}

}

if (start_count > 1 ){
	printf("%s\n", errmsg[38])
	exit (1)
}

if (start_day == ""){
	if (ARGV[2] == template_logOS || ARGV[2] == template_defbkupOS){
	start_day = "monthlydate 01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31"
	start_disp = kanji_char[1]
	}
}

if (start_time == ""){
	if (ARGV[2] == template_logOS || ARGV[2] == template_defbkupOS){
		start_time = "starttime 0000"
	}else{
		start_time = "noexecution ON"
	}
}

if (sub_sys == ""){
	sub_sys = "0"
}

if (dir_path == ""){
	if ( ARGV[2] == template_shutdown ){
		dir_path = sprintf("%s%s", template_path, template_shutdown) 
	}else if ( ARGV[2] == template_reboot ){
		dir_path = sprintf("%s%s", template_path, template_reboot) 
	}else if ( ARGV[2] == template_logOS ){
		dir_path = sprintf("%s%s", template_path, template_logOS) 
	}else if ( ARGV[2] == template_defbkupOS ){
		dir_path = sprintf("%s%s", template_path, template_defbkupOS) 
	}
}

if (bkup_flg){
	if (ARGV[2] == template_shutdown || ARGV[2] == template_reboot){
		printf("%s\n", errmsg[4])
		exit (1)
	}
}
if (! bkup_flg){
	if (ARGV[2] == template_logOS || ARGV[2] == template_defbkupOS){
		printf("%s\n", errmsg[5])
		exit (1)
	}
}

if (gen == ""){
	gen = default_gen
}

if (comp == ""){
	comp = default_comp
}

#*************************************************
# ƥץ졼ȥեɤߵưư򥻥å
#*************************************************

if (d_flg){ 
	index_num = ""
}else{
	index_num = dir_check_1(dir_path)
}

# ƥץ졼Ѱե
system(sprintf("rm -f \"%s/%s\" 2>/dev/null", dir_path, tmp_file))

# ƥץ졼ȥե¸ߥå
rc = system(sprintf("ls %s/%s >/dev/null 2>&1",dir_path, template_name))
if (rc != 0) {
	printf("%s%s%s\n", errmsg[7], template_name, errmsg[6])
	exit (1)
}

# ƥץ졼ȥեɤ߹
cmd = sprintf("cat %s/%s\n",dir_path,template_name)

while (cmd | getline > 0 ) {
	rl = $0

	if ( rl ~ /jobnetname/ ){
		if (d_flg){ 
        		rc = system(sprintf("echo \"%s%s\" >> %s/%s","jobnetname ", jobnet_name_1, dir_path, tmp_file ));
		}else{
        		rc = system(sprintf("echo \"%s%s%s\" >> %s/%s","jobnetname ", jobnet_name_1, index_num, dir_path, tmp_file ));
		}
		if (rc != 0) {
			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
			exit (1)
		}
	}else if ( rl ~ /jobnetcomment/ ){
		if (d_flg){ 
        		rc = system(sprintf("echo \"%s%s%s%s\" >> %s/%s","jobnetcomment ", jobnet_name_2, start_disp, start_disp1, dir_path, tmp_file ));
		}else{
        		rc = system(sprintf("echo \"%s%s_%s%s%s\" >> %s/%s","jobnetcomment ", jobnet_name_2, index_num, start_disp, start_disp1, dir_path, tmp_file ));
		}
		if (rc != 0) {
			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
			exit (1)
		}
        	rc = system(sprintf("echo \"%s\" >> %s/%s", start_time, dir_path, tmp_file ));
		if (rc != 0) {
			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
			exit (1)
		}
	 	if ( start_day != "" ){
       			rc = system(sprintf("echo \"%s\" >> %s/%s",start_day, dir_path, tmp_file ));
	 		if (rc != 0) {
	 			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
	 			exit (1)
	 		}
	 	}
	}else if ( rl ~ /jobparam/ ){
		if (ARGV[2] == template_shutdown || ARGV[2] == template_reboot){
        		rc = system(sprintf("echo \"%s\" >> %s/%s",$0, dir_path, tmp_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
				exit (1)
			}
		}else{
			if (d_flg){ 
        			rc = system(sprintf("echo \"%s%s/%s\" >> %s/%s","jobparam ", dir_path, bkfile_name, dir_path, tmp_file ));
			}else{
        			rc = system(sprintf("echo \"%s%s_%s/%s\" >> %s/%s","jobparam ", dir_path, index_num, bkfile_name, dir_path, tmp_file ));
			}
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
				exit (1)
			}
		}
	}else if ( rl ~ /jobcomment/ ){
        	rc = system(sprintf("echo \"%s\" >> %s/%s",$0, dir_path, tmp_file ));
		if (rc != 0) {
			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
			exit (1)
		}
		if (d_flg){
        		rc = system(sprintf("echo \"%s%s%s\" >> %s/%s","directory ", dir_path, prog_path, dir_path, tmp_file ));
		}else{
        		rc = system(sprintf("echo \"%s%s_%s%s\" >> %s/%s","directory ", dir_path, index_num, prog_path, dir_path, tmp_file ));
		}
		if (rc != 0) {
			printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
			exit (1)
		}
	}else if (( rl ~ /starttime/ ) || ( rl ~ /monthlydate/ ) || ( rl ~ /monthlyweek/ ) || ( rl ~ /noexecution/ ) || ( rl ~ /directory/ )){ 
	      }else{
        		rc = system(sprintf("echo \"%s\" >> %s/%s",$0, dir_path, tmp_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[7], tmp_file, errmsg[8])
				exit (1)
			}
	}

}
close(cmd)

# ƥץ졼Ѱեȥƥץ졼Ȥؤ
if (d_flg){ 
	rc = system(sprintf("mv -f %s/%s %s/%s 2>/dev/null", dir_path, tmp_file, dir_path, template_name))
	if (rc != 0) {
		printf("[%s%s\n", tmp_file, errmsg[9])
		exit(1)
	}
}else{
	# ǥ쥯ȥꥳԡ
	rc = system(sprintf("cp -rp %s %s_%s 2>/dev/null", dir_path, dir_path, index_num))
	if (rc != 0) {
		printf("[%s%s\n", ARGV[2], errmsg[9])
		del_dir()
		exit(1)
	}
	# ԡΰƥץ졼ȥե 
	#rc = system(sprintf("rm -f \"%s/%s\" 2>/dev/null", dir_path, tmp_file))
	rc = system(sprintf("rm \"%s/%s\" 2>/dev/null", dir_path, tmp_file))
	if (rc != 0) {
		printf("[%s%s\n", tmp_file, errmsg[10])
		del_dir()
		exit(1)
	}
	# ԡΰƥץ졼ȥեܥƥץ졼ȥեؤ
	rc = system(sprintf("mv -f %s_%s/%s %s_%s/%s 2>/dev/null", dir_path, index_num, tmp_file, dir_path, index_num, template_name))
	if (rc != 0) {
		printf("[%s%s\n", tmp_file, errmsg[9])
		del_dir()
		exit(1)
	}
}

#*************************************************
# ե˥Хåå衢塢̣ϣΡϣƣƤɲ
#*************************************************

if (bkup_flg){

	# եѰե
	system(sprintf("rm -f \"%s/%s\" 2>/dev/null", dir_path, def_file))

# ե¸ߥå
rc = system(sprintf("ls %s/%s >/dev/null 2>&1",dir_path, bkfile_name))
if (rc != 0) {
	printf("%s%s%s\n", errmsg[11], bkfile_name, errmsg[6])
	if (! d_flg){ 
		del_dir()
	}	
	exit (1)
}

# եɤ߹
	cmd = sprintf("cat %s/%s\n",dir_path, bkfile_name)

	while (cmd | getline > 0 ) {
		rl = $0

		if ( rl ~ /Backup=/ ){
        		rc = system(sprintf("echo \"	Backup=  %s\" >> %s/%s", bkup_path, dir_path, def_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[11], def_file, errmsg[8])
				if (! d_flg){ 
					del_dir()
				}	
				exit (1)
			}
		}else if ( rl ~ /Generation=/ ){
        		rc = system(sprintf("echo \"	Generation=  %s\" >> %s/%s", gen, dir_path, def_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[11], def_file, errmsg[8])
				if (! d_flg){ 
					del_dir()
				}	
				exit (1)
			}
		}else if ( rl ~ /Compression=/ ) {
        		rc = system(sprintf("echo \"	Compression=  %s\" >> %s/%s", comp, dir_path, def_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[11], def_file, errmsg[8])
				if (! d_flg){ 
					del_dir()
				}	
				exit (1)
			}
		}else{
        		rc = system(sprintf("echo \"%s\" >> %s/%s",$0, dir_path, def_file ));
			if (rc != 0) {
				printf("%s%s%s\n", errmsg[11], def_file, errmsg[8])
				if (! d_flg){ 
					del_dir()
				}	
				exit (1)
			}
		}
	}
	close(cmd)

	# Ѱեեؤ
	if (d_flg){ 
		rc = system(sprintf("mv -f %s/%s %s/%s 2>/dev/null", dir_path, def_file, dir_path, bkfile_name))
		if (rc != 0) {
			printf("[%s%s\n", def_file, errmsg[9])
			exit(1)
		}
	}else{
		# ԡΰե򥳥ԡեإԡ 
		rc = system(sprintf("cp -f %s/%s %s_%s/%s 2>/dev/null", dir_path, def_file, dir_path, index_num, bkfile_name))
		if (rc != 0) {
			printf("[%s%s\n", def_file, errmsg[9])
			del_dir()
			exit(1)
		}
		# ԡΰե 
		rc = system(sprintf("rm \"%s/%s\" 2>/dev/null", dir_path, def_file))
		if (rc != 0) {
			printf("[%s%s\n", def_file, errmsg[10])
			del_dir()
			exit(1)
		}
	}
}

#*************************************************
# ֥ͥåȤ
#*************************************************

if (subsys_flg == "1") {
	if (d_flg){ 
		rc = system(sprintf("jobschsetnet -nent %s %s/%s -sys %s" ,ARGV[1],dir_path,template_name,sub_sys));
	}else{
		rc = system(sprintf("jobschsetnet -nent %s %s_%s/%s -sys %s" ,ARGV[1],dir_path,index_num,template_name,sub_sys));
	}
}else{
	if (d_flg){ 
		rc = system(sprintf("jobschsetnet -nent %s %s/%s" ,ARGV[1],dir_path,template_name));
	}else{
		rc = system(sprintf("jobschsetnet -nent %s %s_%s/%s" ,ARGV[1],dir_path,index_num,template_name));
	}
}

if (rc != 0) {
	printf("%s\n", errmsg[12])
	if (! d_flg){ 
		del_dir()
	}	
	exit(1)
}

}

#*************************************************
# ֥å 
#*************************************************
function time_check(hizuke){


if (hizuke == ""){
	printf("%s\n", errmsg[13])
	exit(1)
}
if (length(hizuke) != 4 ){
	printf("%s\n", errmsg[15])
	exit(1)
}
rc = system(sprintf("echo %s | fgrep %s >/dev/null 2>&1", hizuke, "."))
if (rc == 0){
	printf("%s\n", errmsg[15])
	exit(1)
}
    hour = sprintf(substr(hizuke,1,2))
    min = sprintf(substr(hizuke,3,2))

if ((hour >= min_hour && hour <= max_hour) && (min >= min_min)&&(min <= max_min)){
}else{
	printf("%s\n", errmsg[15])
	exit(1)
}

}

#*************************************************
# ֥ƥå 
#*************************************************
function sub_check(sub_num){

if (sub_num == ""){
	printf("%s\n", errmsg[16])
	exit(1)
}

rc = system(sprintf("echo %s | fgrep %s >/dev/null 2>&1", sub_num, "."))
if (rc == 0){
	printf("%s\n", errmsg[18])
	exit(1)
}

if (sub_num >= min_sys && sub_num <= max_sys ){
}else{
	printf("%s\n", errmsg[18])
	exit(1)
}

}

#*************************************************
# å 
#*************************************************
function gen_check(gen_num){

if (ARGV[2] == template_shutdown || ARGV[2] == template_reboot){
	printf("%s\n", errmsg[19])
	exit(1)
}

if (gen_num == ""){
	printf("%s\n", errmsg[20])
	exit(1)
}

rc = system(sprintf("echo %s | fgrep %s >/dev/null 2>&1", gen_num, "."))
if (rc == 0){
	printf("%s\n", errmsg[22])
	exit(1)
}

if (gen_num >= min_gen && gen_num <= max_gen){
}else{
	printf("%s\n", errmsg[22])
	exit(1)
}

}

#*************************************************
# ̥å 
#*************************************************
function comp_check(comp_num){

if (ARGV[2] == template_shutdown || ARGV[2] == template_reboot){
	printf("%s\n", errmsg[23])
	exit(1)
}

if (comp_num == ""){
	printf("%s\n", errmsg[24])
	exit(1)
}

cmd = sprintf("echo \"%s\" | tr '[a-z]' '[A-Z]'", comp_num)
cmd | getline cmd1

if (cmd1 != "ON" && cmd1 != "OFF" ){
		printf("%s\n", errmsg[25])
		exit(1)
}

}

#*************************************************
# å 
#*************************************************
function day_check(day_num){

if (day_num == ""){
	printf("%s\n", errmsg[26])
	exit(1)
}

rc = system(sprintf("echo %s | fgrep %s >/dev/null 2>&1", day_num, "."))
if (rc == 0){
	printf("%s\n", errmsg[27])
	exit(1)
}

# ɤ߹","ʬ䤹
split(day_num, field, ",")

index01 = 1

while (1) {
	if ( field[index01] =="" ){
		break;
	}
	if ((field[index01] >= min_day && field[index01] <= max_day ) || field[index01] == "LAST"){
	}else{
		printf("%s\n", errmsg[27])
		exit(1)
	}
	index01++

}

}

#*************************************************
# å 
#*************************************************
function week_check(week_num){

if (week_num == ""){
	printf("%s\n", errmsg[29])
	exit(1)
}

# ɤ߹","ʬ䤹
split(week_num, field, ",")

index01 = 1

while (1) {
	if ( field[index01] =="" ){
		break;
	}
	if (field[index01] == "SUN" || field[index01] == "MON" || field[index01] == "TUE" || field[index01] == "WED" || field[index01] == "THU" || field[index01] == "FRI" || field[index01] == "SAT"){
	}else{
		printf("%s\n", errmsg[30])
		exit(1)
	}
	index01++

}

}

#*************************************************
# Ƭʸ 
#*************************************************
function week_char_get(week_num){

# ɤ߹","ʬ䤹
split(week_num, field, ",")

if ( field[1] == "SUN" ){
	start_disp1 = kanji_char[5]
}else if ( field[1] == "MON" ){
	start_disp1 = kanji_char[6]
}else if ( field[1] == "TUE" ){
	start_disp1 = kanji_char[7]
}else if ( field[1] == "WED" ){
	start_disp1 = kanji_char[8]
}else if ( field[1] == "THU" ){
	start_disp1 = kanji_char[9]
}else if ( field[1] == "FRI" ){
	start_disp1 = kanji_char[10]
}else if ( field[1] == "SAT" ){
	start_disp1 = kanji_char[11]
}

}

#*************************************************
# Ƭʸ 
#*************************************************
function day_char_get(day_num){

# ɤ߹","ʬ䤹
split(day_num, field, ",")

if (field[1] == "LAST"){
	start_disp1 = kanji_char[4]
}else{
	start_disp1 = field[1]
}


}

#*************************************************
# ǥ쥯ȥå 
#*************************************************
function dir_check(dir_char){

if (dir_char == ""){
	printf("%s\n", errmsg[31])
	exit(1)
}

rc=system(sprintf("ls %s >/dev/null 2>&1",dir_char))
if (rc != 0) {
	printf("%s%s%s\n", errmsg[32], dir_char, errmsg[33])
	exit(1)
}

}

#*************************************************
# ǥ쥯ȥѥ֥ͥå̾ 
#*************************************************
function dirpath_proc(index01){

	index01++
	dir_check( ARGV[index01] )

	rc=system(sprintf("expr x"ARGV[index01]" : x'/' >/dev/null 2>&1"))
	if (rc == 0){
		dir_path = ARGV[index01]
	}else{
		cmd=sprintf("pwd")
	        cmd | getline full_path
        	dir_path = sprintf("%s/%s",full_path, ARGV[index01])
		get_path()
	}

	#֥ͥå̾ʸ֥ͥå̾Σʸ
	cmd = sprintf("basename '%s'", dir_path)

	cmd | getline cmd1
	jobnet_name_1 = sprintf(substr(cmd1,1,8))
	jobnet_name_2 = sprintf(substr(cmd1,1,15))
}

#*************************************************
# 
#*************************************************
function everyday_proc(){

	start_day = "monthlydate 01,02,03,04,05,06,07,08,09,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31"
	start_disp = kanji_char[1]
}

#*************************************************
# 轵
#*************************************************
function weekly_proc(index01){

	index01++
	cmd = sprintf("echo \"%s\" | sed 's/ //g'", ARGV[index01])
	cmd | getline cmd1
	week_check( cmd1 )
	week_char_get( cmd1 )
        start_day = sprintf("%s %s","monthlyweek 0,",cmd1)
	start_disp = kanji_char[2]
}

#*************************************************
# 
#*************************************************
function monthly_proc(index01){

	index01++
	cmd = sprintf("echo \"%s\" | sed 's/ //g'", ARGV[index01])
	cmd | getline cmd1
	day_check( cmd1 )
	day_char_get( cmd1 )
        start_day = sprintf("%s %s","monthlydate",cmd1)
	start_disp = kanji_char[3]
}

#*************************************************
# 
#*************************************************
function time_proc(index01){

	index01++
	time_check( ARGV[index01] )
        start_time = sprintf("%s %s","starttime",ARGV[index01])

}

#*************************************************
# Хååץեǥ쥯 
#*************************************************
function bkup_proc(index01){

	index01++
	if (ARGV[index01] == ""){
		printf("%s\n", errmsg[31])
		exit(1)
	}
	if (ARGV[index01] == "/"){
		printf("%s\n", errmsg[37])
		exit(1)
	}
	bkup_path = ARGV[index01]
}

#*************************************************
# ֥ƥ 
#*************************************************
function subsys_proc(index01){

	index01++
	sub_check( ARGV[index01] )
        sub_sys = ARGV[index01]
}

#*************************************************
#  
#*************************************************
function gen_proc(index01){

	index01++
	gen_check( ARGV[index01] )
        gen = ARGV[index01]
}

#*************************************************
#  
#*************************************************
function comp_proc(index01){

	index01++
	comp_check( ARGV[index01] )
        comp = ARGV[index01]
}

#*************************************************
# ǥ쥯ȥå 
#*************************************************
function dir_check_1(dir_path){

	index03 = 1

	while (1) {
		if (index03 > max_dir){
			printf("%s\n", errmsg[34])
			exit(1)
		}
		rc = system(sprintf("ls %s_%s >/dev/null 2>&1",dir_path,index03))
		if (rc != 0){
			return(index03)
		}
		index03++
	}

}

#*************************************************
# ԡǥ쥯ȥκ 
#*************************************************
function del_dir(){

	# ԡǥ쥯ȥκ
	rc = system(sprintf("rm -rf \"%s_%s\" 2>/dev/null", dir_path, index_num))
	if (rc != 0) {
		printf("[%s_%s%s\n", dir_path, index_num, errmsg[10])
	}

}

#*************************************************
# ѥ"."".."Ѵ
#*************************************************
function get_path() {

	split(dir_path, eachDir, "/")
        maxIdx = 0
        for (xvar in eachDir) {
                maxIdx++
        }
        nowIdx = 1
        temPath[nowIdx] = ""
        for (doti=1; doti<=maxIdx; doti++) {
                if (eachDir[doti] == "..") {
                        if (nowIdx != 1) {
                                nowIdx--
                        }
                }
                else {
                        if (eachDir[doti] !="." && eachDir[doti] !="") {
                                nowIdx++
                                temPath[nowIdx] = sprintf("%s/%s", temPath[nowIdx-1], eachDir[doti])
                        }
                }
        }
        if (nowIdx == 1) {
                dir_path = "/"
        }
        else {
                dir_path = temPath[nowIdx]
        }
}

