#!/bin/nawk -f
# All Rights Reserved, Copyright FUJITSU Limited, 2007
#***********************************************************************
# ǽ            ġ
# ¹Է            log_bkup.sh filename
# ѥ᥿      filename=ե
#***********************************************************************
# ǿ                       (ʵ)
# 0001                                
#***********************************************************************
BEGIN {
	# Ķ
	"uname" | getline osname
	close("uname")
	#*************************************************
	# ե̾
	#*************************************************
	if (osname == "Linux") {
		# for Linux
		myname = "log_bkup_lin.sh"
	} else {
		# for Solaris
		myname = "log_bkup_sol.sh"
	}
	#*************************************************
	# ե륳
	#*************************************************
	DEFAULT = "[default]"
	TARGETFD = "[target file/directory]"
	GENMIN=1
	GENMAX=500
	DATAMAX=1000
	#*************************************************
	# ̥ޥ
	#*************************************************
	if (osname == "Linux") {
		# for Linux
		CMPCMD = "/bin/gzip"
		CMPSUFIX = "gz"
	} else {
		# for Solaris
		CMPCMD = "/usr/bin/compress"
		CMPSUFIX = "Z"
	}
	#*************************************************
	# ԡޥ
	#*************************************************
	if (osname == "Linux") {
		# for Linux
		CPCMD = "/bin/cp -pRL"
	} else {
		# for Solaris
		CPCMD = "/usr/bin/cp -pR"
	}
	#*************************************************
	# Ǥʤǥ쥯ȥꥹ
	#*************************************************
	# ɲäϡ,ɤǶڤä󤹤
	NGDIRLIST="/"
	#*************************************************
	# Хååץǥ쥯ȥ
	#*************************************************
	# ܥץȤΥեѥ
	pbkupdir=sprintf("%s", ENVIRON["PWD"])
	# եѥκǲ̤ΤҤȤľޤǤΥǥ쥯ȥ
	ppbkupdirnamecmd=sprintf("dirname '%s'", pbkupdir)
	ppbkupdirnamecmd | getline ppbkupdirname
	close(ppbkupdirnamecmd)
	# եѥκǲ̤ΤҤȤľΥǥ쥯ȥ̾
	pbkupdirnamecmd=sprintf("basename '%s'", ppbkupdirname)
	pbkupdirnamecmd | getline pbkupdirname
	close(pbkupdirnamecmd)
	# ռ(ǥ쥯ȥ̾˻)
	"date +%Y%m%d" | getline dbkupdirname
	close("date +%Y%m%d")
	# Хååץǥ쥯ȥ
	bkupdirname=sprintf("%s/%s", pbkupdirname, dbkupdirname)
	#*************************************************
	# ǥ쥯ȥ
	#*************************************************
	myfullname=sprintf("%s/%s", pbkupdir, myname)
	mypidcmd = sprintf("ps -ef | grep %s | grep -v grep", myfullname)
	mypidcmd | getline mypidrl
	close(mypidcmd)
	split(mypidrl,pslist)
	mypid=pslist[2]
	workdir = "/var/tmp/OpeTmp."mypid
	#*************************************************
	# ǥեեɤ߹
	#*************************************************
	# ǥեեե
	if (osname == "Linux") {
		deffilelistname="defaultfilelist_lin"
	} else {
		deffilelistname="defaultfilelist_sol"
	}
	dreadfile = sprintf("%s/%s", pbkupdir, deffilelistname)
	dreadcnt = 1
	dreadcmd = sprintf("cat %s\n", dreadfile)
	while (dreadcmd | getline > 0 ) {
		dreadrl = $0
	
		# Ԥ⤷ϹƬ"#"ξɤФ
		if ( dreadrl == "" || dreadrl ~ /^\#/ ) {
			continue
		}

		# ǡɤ߹
		dreadlist[dreadcnt] = dreadrl
		dreadcnt++
	}
	close(dreadcmd)
	#*************************************************
	# ϥ顼å
	#*************************************************
	# 顼
	ERRNOFDDRp = 1
	ERRNOFDDRa = 2
	ERRNOMKDRp = 3
	ERRNOMKDRa = 4
	ERRNORANGE = 5
	ERRNOOPTST = 6
	ERRNGBKUP1 = 7
	ERRNOBKUPp = 8
	ERRNOBKUPa = 9
	ERRNODEFFL = 10
	ERRDATAOVR = 11
	ERRNODEFKW = 12
	ERRNOTGTKW = 13
	ERRNOBKUPD = 14
	ERRNOTFILE = 15
	# 顼åե
	errmsgfilename="log_bkup_errmsg"
	errmsgfile = sprintf("%s/%s", pbkupdir, errmsgfilename)
	# OMGRưĶѿ
	omgrenv="BATCH"
	# OMGR LANGե
	langenvfilename="/opt/systemwalker/etc/systemwalker.reg"
	# LANGꥭ
	langkeyword="^Code="
	# iconvޥ
	ICONVCMD="/usr/bin/iconv"

	# OMGRưƤ뤫Υå
	isomgr = sprintf("%s", ENVIRON["JOBSCH_ENVIRONMENT"])
	if (isomgr == omgrenv) {
		# ե뤫LANG
		kwlinecmd = sprintf("/bin/grep \"%s\" %s", langkeyword, langenvfilename)
		kwlinecmd | getline kwline
		split(kwline,kw,"=")
		close(kwlinecmd)

		# iconvѴơ֥
		if (osname == "SunOS") {
			# Solarisξ
			iconveuc = "eucJP"
			if ( kw[2] == "SJIS" ) {
				# SJISξ
				toiconv = "PCK"
			} else {
				if ( kw[2] == "UTF-8" ) {
					# UTF8ξ
					toiconv = "UTF-8"
				}
			}
		} else {
			# Linuxξ
			iconveuc = "EUC-JP-MS"
			if ( kw[2] == "UTF-8" ) {
				# UTF8ξ
				toiconv = "UTF-8"
			}
		}
		# åΥѴ
		if (kw[2] == "SJIS" || kw[2] == "UTF-8") {
			errmsgrdcmd=sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgfile)
		} else {
			errmsgrdcmd = sprintf("cat %s", errmsgfile)
		}
	} else {
		# LANG
		mylang=sprintf("%s", ENVIRON["LANG"])

		# iconvѴơ֥
		if (osname == "SunOS") {
			# Solarisξ
			iconveuc = "eucJP"
			if ( mylang == "ja_JP.PCK" ) {
				# SJISξ
				toiconv = "PCK"
			} else {
				if ( mylang == "ja_JP.UTF-8" ) {
					# UTF8ξ
					toiconv = "UTF-8"
				}
			}
		} else {
			# Linuxξ
			iconveuc = "EUC-JP-MS"
			if ( mylang == "ja_JP.utf8" || mylang == "ja_JP.UTF-8" ) {
				# UTF8ξ
				toiconv = "UTF-8"
			}
		}
		# åΥѴ
		if (mylang == "ja_JP.PCK" || mylang == "ja_JP.UTF-8" || mylang == "ja_JP.utf8") {
			errmsgrdcmd=sprintf("%s -f %s -t %s %s", ICONVCMD, iconveuc, toiconv, errmsgfile)
		} else {
			errmsgrdcmd = sprintf("cat %s", errmsgfile)
		}
	}
	while (errmsgrdcmd | getline > 0) {
		errmsgrl = $0
	
		# Ԥ⤷ϹƬ"#"ξɤФ
		if ( errmsgrl == "" || errmsgrl ~ /^\#/ ) {
			continue
		}

		split(errmsgrl,edata,",")

		# ǡɤ߹
		errmsg[edata[1]] = edata[2]
	}
	close(errmsgrdcmd)
	#*************************************************
	# եμ
	#*************************************************
	if (ARGV[1] == "") {
		printf("%s\n", errmsg[ERRNODEFFL])
		exit (1)
	}
	defname = ARGV[1]
	# ե¸ߥå
	defnamerc = system(sprintf("ls %s > /dev/null 2>&1", defname))
	if (defnamerc != 0) {
		printf("%s\n", errmsg[ERRNODEFFL])
		exit (1)
	}
	#*************************************************
	# եɤ߹
	#*************************************************
	returncd = 0
	defreadf = 0
	defrlcnt = 1
	chkdef = 0
	chktgt = 0
	chkdefbk = 0
	chkdefgn = 0
	chkdefcm = 0
	cmd = sprintf("cat %s\n",defname)
	while (cmd | getline > 0 ) {
		rl = $0
	
		# Ԥ⤷ϹƬ"#"ξɤФ
		if ( rl == "" || rl ~ /^\#/ ) {
			continue
		}

		# [default]ɤ߹ϡǥեɤ߹ߥե饰ON
		if ( rl ~ "\\[default\\]" ) {
			defreadf=1
			chkdef = 1
			continue
		}

		# [target file/directory]ϡɤФ
		if ( rl ~ "\\[target file/directory\\]" ) {
			defreadf = 0
			chktgt = 1
			continue
		}

		# [default]μɤ߹ϡǥեͼ
		if ( defreadf == 1 ) {
			split(rl,crl)
			if ( crl[1] ~ /Backup/ ) {
				chkdefbk = 1
				split(rl,data,"=")
				split(data[2],a)
				if (a[1] == "") {
					printf("%s\n", errmsg[ERRNOBKUPD])
					close(cmd)
					exit(1)
				}
				split(NGDIRLIST,d,",")
				for(i=1;d[i]!="";i++) {
					if (a[1] == d[i]){
						printf("%s(%s)%s\n", errmsg[ERRNOBKUPp], a[1], errmsg[ERRNOBKUPa])
						close(cmd)
						exit(1)
					}
				}
				defbkupdir=a[1]
			}
			if ( crl[1] ~ /Generation/ ) {
				chkdefgn = 1
				split(rl,data,"=")
				split(data[2],a)
				for(q=1;q<=length(a[1]);q++){
					if (substr(a[1],q,1) ~ "[0-9]") {
						continue
					} else {
						printf("%s(%s)\n", errmsg[ERRNORANGE], DEFAULT)
						close(cmd)
						exit (1)
					}
				}
				if (GENMIN <= a[1] && a[1] <= GENMAX) {
					defgen = a[1]
				} else {
					printf("%s(%s)\n", errmsg[ERRNORANGE], DEFAULT)
					close(cmd)
					exit (1)
				}
			}
			if ( crl[1] ~ /Compression/ ) {
				chkdefcm = 1
				split(rl,data,"=")
				split(data[2],a)
				if (toupper(a[1]) == "ON" || toupper(a[1]) == "OFF") {
					defcmp = toupper(a[1])
				} else {
					printf("%s(%s)\n", errmsg[ERRNOOPTST], DEFAULT)
					close(cmd)
					exit (1)
				}
			}
			continue
		}
		# ǡ1000԰ǤС˳Ǽ
		if ( defrlcnt <= DATAMAX ) {
			rlarr[defrlcnt] = rl
			defrlcnt++
		} else {
			printf("%s\n", errmsg[ERRDATAOVR])
			returncd = 1
			break
		}
	}
	close(cmd)

	# [default]ʤХ顼åϤ
	if (chkdef == 0) {
		printf("%s\n", errmsg[ERRNODEFKW])
		exit (1)
	}
	# [target file/directory]ʤХ顼åϤ
	if (chktgt == 0) {
		printf("%s\n", errmsg[ERRNOTGTKW])
		exit (1)
	}

	# Backup=ʤХ顼åϤ
	if (chkdefbk == 0) {
		printf("%s\n", errmsg[ERRNOBKUPD])
		exit (1)
	}
	# Generation=ʤХ顼åϤ
	if (chkdefgn == 0) {
		printf("%s(%s)\n", errmsg[ERRNORANGE], DEFAULT)
		exit (1)
	}
	# Compression=ʤХ顼åϤ
	if (chkdefcm == 0) {
		printf("%s(%s)\n", errmsg[ERRNOOPTST], DEFAULT)
		exit (1)
	}

	# ǡɤ߹ϡ֥롼Ф
	for ( i = 1; rlarr[i] != ""; i++) {
		mainProc(rlarr[i], defbkupdir, defgen, defcmp);
	}
	exit (returncd)
}

#*************************************************
# ǡ
#*************************************************
function mainProc( strReadLine, defbkupdir ,defgen ,defcmp ){
	target = ""
	bkupdir = ""
	gen = ""
	cmp = ""

	# ɤ߹եԤ","ʬ䤹
	split(strReadLine, field, ",")

	# оݥե/ǥ쥯ȥ
	split(field[1],f)
	if (f[1] == "") {
		printf("%s\n", errmsg[ERRNOTFILE])
		returncd = 1
		return;
	}
	target = f[1]

	# Хååץǥ쥯ȥ
	split(field[2],b)
	if (b[1] == "") {
		bkupdir = defbkupdir
	} else {
		split(NGDIRLIST,d,",")
		for(j=1;d[j]!="";j++) {
			if (b[1] == d[j]){
				printf("%s(%s)%s\n", errmsg[ERRNOBKUPp], b[1], errmsg[ERRNOBKUPa])
				returncd = 1
				return;
			}
		}
		bkupdir = b[1]
	}

	# 
	split(field[3],g)
	if (g[1] == "") {
		gen = defgen
	} else {
		for(w=1;w<=length(g[1]);w++){
			if (substr(g[1],w,1) ~ "[0-9]") {
				continue
			} else {
				printf("%s(%s)\n", errmsg[ERRNORANGE], target)
				close(cmd)
				exit (1)
			}
		}
		if (GENMIN <= g[1] && g[1] <= GENMAX) {
			gen = g[1]
		} else {
			printf("%s(%s)\n", errmsg[ERRNORANGE], target)
			returncd = 1
			return;
		}
	}

	# ̥ץ
	split(field[4],c)
	if (c[1] == "") {
		cmp = defcmp
	} else {
		if (toupper(c[1]) == "ON" || toupper(c[1]) == "OFF") {
			cmp = toupper(c[1])
		} else {
			printf("%s(%s)\n", errmsg[ERRNOOPTST], target)
			returncd = 1
			return;
		}
	}

	# оݥե뤬¸ߤʤ
	rc=system(sprintf("ls %s >/dev/null 2>&1", target))
	if (rc != 0) {
		for ( l = 1; dreadlist[l] != ""; l++ ) {
			if ( target == dreadlist[l] ) {
				return;
			}
		}
		# ɤФå
		printf("%s(%s)%s\n",errmsg[ERRNOFDDRp], target, errmsg[ERRNOFDDRa])
		returncd = 1
		return;
	}

	targetlistcmd=sprintf("ls -d %s", target)
	while(targetlistcmd | getline) {
		targetlist=$0

		# оݥե̾
		cmd2 = sprintf("basename '%s'", targetlist)
		bkupfname = ""
		cmd2 | getline bkupfname
		close(cmd2)

		# Хååǥ쥯ȥ¸ߥå
		rc=system(sprintf("ls %s/%s >/dev/null 2>&1", bkupdir, bkupdirname))
		if (rc != 0) {
			# Хååǥ쥯ȥ꤬¸ߤʤ硢mkdir
			rc2=system(sprintf("mkdir -p %s/%s >/dev/null 2>&1", bkupdir, bkupdirname))
			if (rc2 !=0) {
				printf("%s(%s/%s)%s\n", errmsg[ERRNOMKDRp], bkupdir, bkupdirname, errmsg[ERRNOMKDRa])
				returncd = 1
				close(targetlistcmd)
				return
			}
		}

		# ̥ץȽ̤Хååפ
		if ( cmp == "ON" ) {
			# оݥե뤬ե뤫ǥ쥯ȥ꤫å
			rc31=system(sprintf("/usr/bin/test -d %s >/dev/null 2>&1", targetlist))
			if (rc31 == 0) {
				# ǥ쥯ȥξ
				# оݥǥ쥯ȥΥǥ쥯ȥ̾
				gettdircmd=sprintf("dirname '%s'", target)
				gettdircmd | getline tdirname
				close(gettdircmd)

				# оݥǥ쥯ȥκǲ̥ǥ쥯ȥ̾
				gettfilecmd=sprintf("basename '%s'", target)
				gettfilecmd | getline tfilename
				close(gettfilecmd)

				# ǥ쥯ȥ
				rctmp=system(sprintf("ls -d %s >/dev/null 2>&1", workdir))
				if (rctmp == 0) {
					system(sprintf("rm -rf %s", workdir))
				}
				system(sprintf("mkdir %s", workdir))
				# Хååץǥ쥯ȥǥ쥯ȥ˥ԡ
				system(sprintf("cd %s; %s %s %s", tdirname, CPCMD, tfilename, workdir))
				# ǥ쥯ȥ˰ưоݥǥ쥯ȥ򰵽̤ƥХååפ
				rc3=system(sprintf("cd %s; tar cvf - %s 2>/dev/null | %s > %s/%s/%s/%s.tar.%s 2>/dev/null", workdir, tfilename, CMPCMD, bkupdir, bkupdirname, bkupdname, bkupfname, CMPSUFIX))
				# ǥ쥯ȥ
				system(sprintf("rm -rf %s", workdir))
			} else {
				# եξ
				# Хååץǥ쥯ȥоݥե򥳥ԡ
				rc32=system(sprintf("%s %s %s/%s/%s >/dev/null 2>&1", CPCMD, targetlist, bkupdir, bkupdirname, bkupfname))
				if (rc32 != 0) {
					printf("%s(%s)\n", errmsg[ERRNGBKUP1], targetlist)
					returncd = 1
					close(targetlistcmd)
					return
				}
				rc3=system(sprintf("%s -f %s/%s/%s 2>/dev/null", CMPCMD, bkupdir, bkupdirname, bkupfname))
			}
		} else {
			# ̤ʤ
			rc3=system(sprintf("%s %s %s/%s/%s >/dev/null 2>&1", CPCMD, targetlist, bkupdir, bkupdirname, bkupfname))
		}
		if (rc3 != 0) {
			# ХååפԤ
			printf("%s(%s)\n", errmsg[ERRNGBKUP1], targetlist)
			returncd = 1
			close(targetlistcmd)
			return
		}

		# Хååץǥ쥯ȥ꤫оݥե򸡺
		# ĶƤŤХååץե
		filecntcmd=sprintf("ls -d %s/%s/*/%s %s/%s/*/%s.tar.%s %s/%s/*/%s.%s 2>/dev/null | wc -l", bkupdir, pbkupdirname, bkupfname, bkupdir, pbkupdirname, bkupfname, CMPSUFIX, bkupdir, pbkupdirname, bkupfname, CMPSUFIX)
		filecntcmd | getline filecnt
		close(filecntcmd)
		nfilecnt=sprintf("%d", filecnt)
		if (nfilecnt > gen) {
			for(k=0; k<nfilecnt-gen; k++) {
				# ָŤХååץե
				# ա101ʾBroken Pipeǥ顼Ȥʤ뤿ᡢ
				#	ȤsortƤ
				cntfilename=sprintf("ls -d -1 %s/%s/*/%s %s/%s/*/%s.tar.%s %s/%s/*/%s.%s 2>/dev/null | sort", bkupdir, pbkupdirname, bkupfname, bkupdir, pbkupdirname, bkupfname, CMPSUFIX, bkupdir, pbkupdirname, bkupfname, CMPSUFIX)
				cntfilename | getline targetfilename
				close(cntfilename)
				rc4=system(sprintf("/usr/bin/test -d %s >/dev/null 2>&1", targetfilename))
				if (rc4 == 0) {
					# ǥ쥯ȥξ
					matdir=sprintf("^%s/%s/[0-9][0-9][0-9][0-9][0-9][0-9][0-9][0-9]", bkupdir, pbkupdirname)
					if ( match(targetfilename, matdir) ) {
						system(sprintf("rm -rf %s", targetfilename))
					}
				} else {
					# եξ
					system(sprintf("rm -f %s", targetfilename))
				}

				# ָŤХååץե뤬֤Ƥǥ쥯ȥ۲
				# ե뤬¸ߤʤʤäϡǥ쥯ȥ
				cmd3=sprintf("dirname %s", targetfilename)
				cmd3 | getline dirnm
				close(cmd3)
				filecntcmd2=sprintf("ls %s | wc -l", dirnm)
				filecntcmd2 | getline filecnt2
				close(filecntcmd2)
				nfilecnt2=sprintf("%d", filecnt2)
				if (nfilecnt2 == 0) {
					system(sprintf("rmdir %s", dirnm))
				}
			}
		}
	}
	close(targetlistcmd)
	return
}
